class VALIDATEBASE
{
private:
  static bool IsUnicode( const uchar &Bytes[] )
  {
    return((::ArraySize(Bytes) > 1) && (Bytes[0] == 0xFF) && (Bytes[1] == 0xFE));
  }

protected:
  static void Unicode2ANSI( uchar &Bytes[] )
  {
    if (VALIDATEBASE::IsUnicode(Bytes))
    {
      const int Size = (::ArraySize(Bytes) >> 1) - 1;

      for (int i = 0; i < Size; i++)
        Bytes[i] = Bytes[(i << 1) + 2];

      ::ArrayResize(Bytes, Size);
    }
  }

  static string StringBetween( string &Str, const string StrBegin, const string StrEnd = NULL )
  {
    string Res = NULL;
    int PosBegin = ::StringFind(Str, StrBegin);

    if ((PosBegin >= 0) || (StrBegin == NULL))
    {
      PosBegin = (PosBegin >= 0) ? PosBegin + ::StringLen(StrBegin) : 0;

      const int PosEnd = ::StringFind(Str, StrEnd, PosBegin);

      if (PosEnd != PosBegin)
        Res = ::StringSubstr(Str, PosBegin, (PosEnd >= 0) ? PosEnd - PosBegin : -1);

      Str = (PosEnd >= 0) ? ::StringSubstr(Str, PosEnd + ::StringLen(StrEnd)) : NULL;

      if (Str == "")
        Str = NULL;
    }

    return((Res == "") ? NULL : Res);
  }

  static bool StringReplace( string &Str, const string StrBegin, const string StrEnd, const string StrNew )
  {
    const int PosBegin = ::StringFind(Str, StrBegin);
    const bool Res = (PosBegin >= 0);

    if (Res)
    {
      const int PosEnd = ::StringFind(Str, StrEnd, PosBegin);

      Str = ::StringSubstr(Str, 0, PosBegin + ::StringLen(StrBegin)) + StrNew + ((PosEnd >= 0) ? ::StringSubstr(Str, PosEnd): NULL);
    }

    return(Res);
  }
};